/****************************************************************
EDITLIN2.C

public int
vt_EditLine2 (line_buff, start_row, start_col, max_chars,pad_char)
	char *line_buff;
	int start_row, start_col;
	int max_chars;
	int pad_char;
	{
	int cursor;
	int ch, length, repeat_count;
	int i;
	
	vt_CursorAt(start_row,start_col);	
	for (i=0; i<max_chars; i++) vt_AddChar(pad_char);	

	vt_StringAt(line_buff, start_row, start_col);

	repeat_count = 1;
	cursor = length = strlen (line_buff);	
	ch = 0;

	for(;;){
		if (--repeat_count <= 1) repeat_count = 1;

		vt_CursorAt (start_row,start_col+cursor);
		vt_Refresh();

		if (ch==CTL('U') || repeat_count==1)
			{
			ch = io_GetChar();
			}

		/* check for specific terminator and some standard ones */
		if (ch==ESC || ch==CR || ch==LF     
		    || ch==CTL('I') || ch==CTL('S') || ch==CTL('R') 
		    || ch==CTL('X') || ch==CTL('Z') || ch==CTL('G')
		    || ch==CTL('C')		
		    ) 
			{ return(ch); }

		if (isAppropriate(ch))
			{
			if (cursor>=length)
				{
				if (length>=max_chars-1)
					{
					/* don't advance cursor, or
					 * increase the length 
					 */
					line_buff[cursor-1]=ch;
					vt_CursorAt(start_row,
						  start_col+cursor-1);
					vt_Refresh();	
					vt_PutChar(ch);
					continue;
					}
				/* else increase length & cursor */
				length++;
				line_buff[cursor]=ch;
				vt_PutChar(ch);
				cursor++;     /* advance cursor */
				line_buff[cursor]='\0'; 
				continue;
				}
			/* else */
			line_buff[cursor]=ch;
			vt_PutChar(ch);
			cursor++;     /* advance cursor */
			continue;
			}

		switch (ch)
			{
		case CTL('U'):		++repeat_count;
					repeat_count *= 4;  
					repeat_count--;
								continue;

		case CTL('B'):
		case LEFT_ARROW:  	cursor = (cursor>0 
						 ? cursor-1
						 : 0);		break;

		case CTL('F'):
		case RIGHT_ARROW: 	cursor = (cursor < length
						 ? cursor+1
						 : length);	break;

		case CTL('A'):
		case HOME_KEY:		cursor = 0;		break;

		case CTL('E'):
		case RET_KEY:
		case END_KEY:		cursor = length;	break;

		case CTL('K'):		{
					int i;
					i = length-cursor;
					while (i--) vt_PutChar(pad_char);
					}
					length = cursor;
					line_buff [cursor]='\0';
								break;
		
		case CTL('D'):
		case DEL_KEY:		
			if (cursor<length && length>0)
				{
				length--;
				shift_Nbytes (&(line_buff[cursor+1]),
					&(line_buff[cursor]),
					length-cursor+1); /*incl NUL */
				vt_StringAt(&(line_buff [cursor]), 
					start_row,
					start_col+cursor);
				vt_PutChar(pad_char);
				}
								break;

		case BSP_KEY:		
			if (cursor<length && cursor>0)
				{
				length--; cursor--;
				shift_Nbytes(&(line_buff[cursor+1]),
					&(line_buff[cursor]),
					length-cursor+1);  /*incl NUL */
				vt_StringAt( &(line_buff[cursor]), 
					start_row, 
					start_col+cursor);
				vt_PutChar(pad_char);
				}
			else if (cursor>=length && cursor>0)
				{
				length--; cursor--;
				line_buff[cursor]='\0';
				vt_CursorAt(start_row,start_col+cursor);
				vt_PutChar(pad_char);
				}
								break;

			}	/* end switch */
		} /*end loop */
	} /* end function */
